﻿Imports System.IO
Imports EasyCrypt
Public Class addDiary
#Region "Variablen"
    Dim encryptFile As String = System.IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "PasswordDiary\cryptdry.txt") 'Pfad, an dem sich das Archiv befindet
    Dim rtbList As New List(Of String) 'Zwischenspeicher für den entschlüsselten Text
#End Region

#Region "GUI"
    Private Sub btnApply_Click(sender As Object, e As EventArgs) Handles btnApply.Click 'Wird ausgeführt, wenn der Knopf btnApply gedrückt wurde
        If compareText() = True Then
            If Not rtbMain.Text.Equals("") Then
                Dim msg = MessageBox.Show("Falls Sie schon ein vorhandenes Diary-Archiv haben, wird dieses ersetzt! Wollen Sie fortfahren?", "PasswordDiary", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
                If msg = DialogResult.No Then

                ElseIf msg = DialogResult.Yes Then
                    If encryptForm() = True Then
                        Me.Close()
                    End If
                End If
            Else
                MessageBox.Show("Ihr Diary-Archiv kann nicht leer sein!", "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub

    Private Sub txtPword1_TextChanged(sender As Object, e As EventArgs) Handles txtPword1.TextChanged
        'Wird ausgeführt, wenn sich der Text der TextBox txtPword1 ändert
        compareText()
    End Sub

    Private Sub txtPword2_TextChanged(sender As Object, e As EventArgs) Handles txtPword2.TextChanged
        'Wird ausgeführt, wenn sich der Text der TextBox txtPword2 ändert
        compareText()
    End Sub

    Private Sub addDiary_Load(sender As Object, e As EventArgs) Handles MyBase.Load 'Wird ausgeführt, wenn die Form aufgerufen wird
        MessageBox.Show("Falls Sie schon ein vorhandenes Diary-Archiv haben, wird dieses beim Bestätigen dieses Formulares ersetzt!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)
        lblNote.Text = ""
    End Sub
#End Region

#Region "Funktionen & Subs"
    Function compareText() As Boolean 'Wird in den TextChange Methoden aufgerufen.
        'Dient als vergleich oder zur überprüfung der beiden Texte aus txtPword1 und txtPword2
        If Not String.IsNullOrWhiteSpace(txtPword1.Text) AndAlso Not String.IsNullOrWhiteSpace(txtPword2.Text) Then

            If Not txtPword1.TextLength < 8 AndAlso Not txtPword2.TextLength < 8 Then

                If txtPword1.Text.Equals(txtPword2.Text) Then
                    picBox.Image = My.Resources.hakerl
                    lblNote.Text = ""
                    Return True
                Else
                    picBox.Image = My.Resources.cross
                    lblNote.Text = "Das Passwort ist ungleich!"
                    Return False
                End If

            Else
                picBox.Image = My.Resources.cross
                lblNote.Text = "Das Passwort muss mindestens 8 Zeichen lang sein!"
                Return False
            End If

        Else
            picBox.Image = My.Resources.cross
            lblNote.Text = "Das Passwort ist leer!"
            Return False
        End If

        picBox.Image = My.Resources.cross
        Return False
    End Function

    Function encryptForm() As Boolean 'Ruft Methode zum verschlüsseln auf und schreibt den verschlüsselten Text neu in das Archiv
        If IO.File.Exists(encryptFile) Then
            IO.File.Delete(encryptFile)
        End If

        Try
            If convert2List() = True Then
                IO.File.WriteAllLines(encryptFile, rtbList)
                rtbList.Clear()
                Return True
            End If
        Catch ex As Exception
            MessageBox.Show("Fehler:" & vbNewLine & ex.ToString(), "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return False
        End Try

        Return False
    End Function

    Function convert2List() As Boolean 'Verschlüsselt den angegebenen Text und konvertiert diesen im nächsten Schritt zu einer List(Of String)
        Try
            For Each line In rtbMain.Lines
                line = EasyCrypt.EasyCrypt.Cryptography.AES.encrypt_String(line, txtPword1.Text)
                rtbList.Add(line)
            Next
            Return True
        Catch ex As Exception
            MessageBox.Show("Fehler:" & vbNewLine & ex.ToString(), "Fehler")
            Return False
        End Try
        Return False
    End Function
#End Region
End Class