﻿Imports EasyCrypt
Public Class frmChangePword
#Region "Variablen"
    Dim encryptFile As String = System.IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "PasswordDiary\cryptdry.txt") 'Pfad wo das Archiv gespeichert ist
    Dim decryptText As New List(Of String) 'Dient als Zwischenablage für entschlüsselten Text - wird oft (manchmal auch unnötig) gecleared, um bugs zu vermeiden.
    Dim encryptList As New List(Of String) 'Dient als Zwischenablage für den verschlüsselten Text
#End Region

#Region "GUI"
    Private Sub frmChangePword_Load(sender As Object, e As EventArgs) Handles MyBase.Load 'Load Ereigniss der Form
        lblNote.Text = ""
    End Sub

    Private Sub txtPwordNow_LostFocus(sender As Object, e As EventArgs) Handles txtPwordNow.LostFocus 'Wird ausgeführt, wenn die TextBox txtPwordNow den Fokus verliert
        decryptText.Clear()
        If tryDecrypt() = True Then
            If testDecrypted() = True Then
                picBoxPwordNow.Image = My.Resources.hakerl
                lblNote.Text = ""
            End If
        End If
    End Sub

    Private Sub txtPwordChange1_TextChanged(sender As Object, e As EventArgs) Handles txtPwordChange1.TextChanged
        'Wird ausgeführt, wenn sich der Text der TextBox txtPwordChange1 ändert
        compareText()
    End Sub

    Private Sub txtPwordChange2_TextChanged(sender As Object, e As EventArgs) Handles txtPwordChange2.TextChanged
        'Wird ausgeführt, wenn sich der Text der TextBox txtPwordChange2 ändert
        compareText()
    End Sub

    Private Sub btnApply_Click(sender As Object, e As EventArgs) Handles btnApply.Click 'Wird ausgeführt, wenn der Knopf btnApply gedrückt wird
        If compareText() = True Then
            Dim msg = MessageBox.Show("Sind Sie sicher, dass Sie Ihr Passwort ändern wollen?", "PasswordDiary", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question)
            If msg = DialogResult.Yes Then
                If startEncrypting() = True Then
                    Me.Close()
                End If
            ElseIf msg = DialogResult.No Then
                resetAll()
                Me.Close()
            End If
        End If
    End Sub
#End Region

#Region "Funktionen & Subs"
    Function compareText() As Boolean 'Wird in den TextChange Methoden aufgerufen.
        'Dient als vergleich oder zur überprüfung der beiden Texte aus txtPwordChange1 und txtPwordChange2
        If Not String.IsNullOrWhiteSpace(txtPwordChange1.Text) AndAlso Not String.IsNullOrWhiteSpace(txtPwordChange2.Text) Then

            If Not txtPwordChange1.TextLength < 8 AndAlso Not txtPwordChange2.TextLength < 8 Then

                If txtPwordChange1.Text.Equals(txtPwordChange2.Text) Then
                    picBoxPwordChange.Image = My.Resources.hakerl
                    lblNote.Text = ""
                    Return True
                Else
                    picBoxPwordChange.Image = My.Resources.cross
                    lblNote.Text = "Das Passwort ist ungleich!"
                    picBoxPwordChange.Image = My.Resources.cross
                    Return False
                End If

            Else
                picBoxPwordChange.Image = My.Resources.cross
                lblNote.Text = "Das Passwort muss mindestens 8 Zeichen lang sein!"
                picBoxPwordChange.Image = My.Resources.cross
                Return False
            End If

        Else
            picBoxPwordChange.Image = My.Resources.cross
            lblNote.Text = "Das Passwort ist leer!"
            picBoxPwordChange.Image = My.Resources.cross
            Return False
        End If

        picBoxPwordChange.Image = My.Resources.cross
        Return False
    End Function

    Function tryDecrypt() As Boolean 'Hier wird versucht, den Text aus dem angelegten Archiv zu entschlüsseln.
        'Mögliche kleine Fehler werden In das Label lblNote geschrieben, fatale oder unbekannte Fehler werden via MessageBox ausgegeben
        If Not String.IsNullOrWhiteSpace(txtPwordNow.Text) Then
            If IO.File.Exists(encryptFile) Then
                Try
                    encryptList.Clear()
                    encryptList.AddRange(IO.File.ReadAllLines(encryptFile))
                    decryptText.Clear()
                    For Each line In encryptList
                        decryptText.Add(EasyCrypt.EasyCrypt.Cryptography.AES.decrypt_String(line, txtPwordNow.Text))
                    Next
                    Return True
                Catch ex As Exception
                    MessageBox.Show("Fehler!" & vbNewLine & ex.ToString(), "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    lblNote.Text = "Ein unbekannter Fehler ist aufgetreten!"
                    picBoxPwordNow.Image = My.Resources.cross
                    Return False
                End Try
            Else
                lblNote.Text = "Es wurde noch kein Diary-Archiv angelegt!"
                picBoxPwordNow.Image = My.Resources.cross
                Return False
            End If
        Else
            lblNote.Text = "Bitte geben Sie Ihr Passwort ein!"
            picBoxPwordNow.Image = My.Resources.cross
            Return False
        End If
        picBoxPwordNow.Image = My.Resources.cross
        Return False
    End Function

    Function testDecrypted() As Boolean 'Testet den entschlüsselten Text, steht in allen Items "error", ist das Passwort falsch
        Dim listItms As Integer = decryptText.Count()
        Dim exists As Integer

        For Each lines In decryptText
            If lines.Equals("error") Then
                exists += 1
            End If
        Next

        If exists >= listItms Then
            picBoxPwordNow.Image = My.Resources.cross
            lblNote.Text = "Falsches Passwort!"
            Return False
        Else
            Return True
        End If
    End Function

    Function startEncrypting() As Boolean 'Startet das verschlüsseln, wenn das geänderte Passwort bestätigt wurde
        Try
            testDecrypted()
            If IO.File.Exists(encryptFile) Then
                IO.File.Delete(encryptFile)
            End If

            If convert2List() = True Then
                IO.File.WriteAllLines(encryptFile, encryptList)
                resetAll()
                Return True
            Else
                Return False
            End If
            Return True
        Catch ex As Exception
            MessageBox.Show("Fehler:" & vbNewLine & ex.ToString())
            Return False
        End Try
        Return False
    End Function

    Function convert2List() As Boolean 'Verschlüsselt den entschlüsselten Text und konvertiert diesen im nächsten Schritt zu einer List(Of String)
        Try
            encryptList.Clear() 'Sehr Wichtig: schwer zu findender Bug. Ist diese Zeile nicht vorhanden, werden "error"-Items hinzugefügt
            For Each line In decryptText
                line = EasyCrypt.EasyCrypt.Cryptography.AES.encrypt_String(line, txtPwordChange1.Text)
                encryptList.Add(line)
            Next
            Return True
        Catch ex As Exception
            MessageBox.Show("Fehler:" & vbNewLine & ex.ToString(), "Fehler")
            Return False
        End Try
        Return False
    End Function

    Sub resetAll() 'Setzt alle wichtigen Variablen zurück.
        encryptList.Clear()
        decryptText.Clear()
        txtPwordChange1.Text = ""
        txtPwordChange2.Text = ""
        txtPwordNow.Text = ""
    End Sub
#End Region
End Class