﻿Imports EasyCrypt
Imports System.IO
Public Class frmMain
#Region "Variablen"
    Dim encryptFile As String = System.IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "PasswordDiary\cryptdry.txt") 'Pfad, an dem sich das Archiv befindet
    Dim decryptText As New List(Of String) 'Dient als Zwischenablage für entschlüsselten Text
    Dim encryptList As New List(Of String) 'Dient als Zwischenablage für den verschlüsselten Text
    Dim txtToEncrypt As New List(Of String)
    Dim isTextChanged As Boolean = False '(Für showDecrypt) Variable die festlegt, ob der geladene Text geändert wurde
    Dim rtbList As New List(Of String) '(Für showDecrypt) Zwischenablage für den verschlüsselten Text
#End Region

#Region "GUI"
    Private Sub frmMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load 'Wird ausgeführt, wenn die Form aufgerufen wird (Startformular)
        If Not IO.Directory.Exists(System.IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "PasswordDiary")) Then IO.Directory.CreateDirectory(System.IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "PasswordDiary"))
    End Sub

    Private Sub btnOk_Click(sender As Object, e As EventArgs) Handles btnOk.Click 'Wird ausgeführt, wenn der Knopf btnOK gedrückt wurde
        If tryDecrypt() = True Then
            If testDecrypted() = True Then
                prepareChangeShow(True)
            Else
                MessageBox.Show("Falsches Passwort!", "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
                resetAll()
            End If
        End If
    End Sub

    Private Sub llblAddDiary_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles llblAddDiary.LinkClicked
        'Wird ausgeführt, wenn das LinkLabel llblAddDiary gedrückt wurde
        Dim addDiary As New addDiary
        addDiary.ShowDialog()
    End Sub

    Private Sub txtPword_KeyDown(sender As Object, e As KeyEventArgs) Handles txtPword.KeyDown
        'Überprüft ob die Enter Taste gedrückt wurde. Wird ausgeführt, wenn ein Knopf gedrückt wird, währen txtPword den Focus hat
        If e.KeyCode = Keys.Enter Then
            btnOk_Click(sender, e)
        End If
    End Sub

    Private Sub llblChangePword_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles llblChangePword.LinkClicked
        'Wird ausgeführt, wenn das LinkLabel llblChangePword gedrückt wurde
        Dim frmPword As New frmChangePword
        frmPword.ShowDialog()
    End Sub
#End Region

#Region "Funktionen&Subs"
    Function tryDecrypt() As Boolean 'Hier wird versucht, den Text aus dem angelegten Archiv zu entschlüsseln.
        'Mögliche kleine Fehler werden In das Label lblNote geschrieben, fatale oder unbekannte Fehler werden via MessageBox ausgegeben
        If Not String.IsNullOrWhiteSpace(txtPword.Text) Then
            If IO.File.Exists(encryptFile) Then
                Try
                    encryptList.AddRange(IO.File.ReadAllLines(encryptFile))
                    For Each line In encryptList
                        decryptText.Add(EasyCrypt.EasyCrypt.Cryptography.AES.decrypt_String(line, txtPword.Text))
                    Next
                    Return True
                Catch ex As Exception
                    MessageBox.Show("Fehler!" & vbNewLine & ex.ToString(), "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    resetAll()
                    Return False
                End Try
            Else
                MessageBox.Show("Es wurde noch kein Diary angelegt!", "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
                resetAll()
                Return False
            End If
        Else
            MessageBox.Show("Bitte geben Sie Ihr Passwort ein!", "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
            resetAll()
            Return False
        End If
        MessageBox.Show("Ein unbekannter Fehler ist aufgetreten!", "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
        resetAll()
        Return False
    End Function

    Function testDecrypted() As Boolean 'Testet den entschlüsselten Text, steht in allen Items "error", ist das Passwort falsch
        Dim listItms As Integer = decryptText.Count()
        Dim exists As Integer

        For Each lines In decryptText
            If lines.Equals("error") Then
                exists += 1
            End If
        Next

        If exists = listItms Then
            Return False
        Else
            Return True
        End If
    End Function

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="ShowHide">Wenn True dann Show, Wenn False dann Hide</param>
    Sub prepareChangeShow(ShowHide As Boolean)
        If ShowHide = True Then
            Me.Size = New Size(650, 315)
            Me.FormBorderStyle = FormBorderStyle.Sizable
            pnlShowDecrypt.Visible = True
            pnlMain.Visible = False
            pnlShowDecrypt.BringToFront()
            loadShowDecrypt()
        ElseIf ShowHide = False Then
            Me.Size = New Size(609, 169)
            Me.FormBorderStyle = FormBorderStyle.FixedSingle
            pnlMain.Visible = True
            pnlShowDecrypt.Visible = False
            pnlMain.BringToFront()
            resetAll()
        End If
    End Sub

    Sub resetAll() 'Setzt alle wichtigen Variablen zurück
        txtPword.Text = ""
        rtbMain.Clear()
        decryptText.Clear()
        encryptList.Clear()
    End Sub
#End Region

#Region "showDecrypt"

#Region "GUI"
    Private Sub loadShowDecrypt() 'Wird ausgeführt, wenn die der entschlüsselte Text angezeigt werden soll
        Dim cntItms As Integer = decryptText.Count()
        Dim cntUp As Integer
        For Each line In decryptText
            cntUp += 1
            If cntUp = cntItms Then
                rtbMain.Text = rtbMain.Text & line
            Else
                rtbMain.Text = rtbMain.Text & line & vbNewLine
            End If
        Next
        isTextChanged = False
    End Sub

    Private Sub frmMain_SizeChanged(sender As Object, e As EventArgs) Handles Me.SizeChanged
        'berechnet die Position betroffener GUI-Elemente, die sich beim ändern der Größe der Form verschieben müssen
        rtbMain.Height = Me.Height - 70

        Dim frmWidthHalf As Integer = Math.Round(Me.Width / 2)
        Dim btnWidthHalf As Integer = Math.Round(btnApply.Width / 1.5)
        btnApply.Location = New Point(frmWidthHalf - btnWidthHalf, Me.Height - 66)

        separator.Width = Me.Width
        separator.Location = New Point(0, Me.Height - 70)
    End Sub

    Private Sub rtbMain_TextChanged(sender As Object, e As EventArgs) Handles rtbMain.TextChanged
        'Wird ausgeführt, wenn sich der Text der RichTextBox rtbMain ändert
        isTextChanged = True
    End Sub

    Private Sub btnApply_Click(sender As Object, e As EventArgs) Handles btnApply.Click  'Wird ausgeführt, wenn der Knopf btnApply gedrückt wird
        If isTextChanged = True Then
            Dim msg = MessageBox.Show("Wollen Sie Ihre Änderungen speichern?", "PasswordDiary", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question)

            If msg = DialogResult.Yes Then
                If encryptForm() = True Then
                    prepareChangeShow(False)
                Else
                    MessageBox.Show("Es ist ein unbekannter Fehler aufgetreten!", "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Me.Close()
                End If
            ElseIf msg = DialogResult.No Then
                prepareChangeShow(False)
            ElseIf msg = DialogResult.Cancel Then

            End If
        Else
            prepareChangeShow(False)
        End If
    End Sub
#End Region

#Region "Funktionen & Subs"
    Function encryptForm() As Boolean 'Ruft Methode zum verschlüsseln auf und schreibt den verschlüsselten Text neu in das Archiv
        If IO.File.Exists(encryptFile) Then
            IO.File.Delete(encryptFile)
        End If

        Try
            If convert2List() = True Then
                IO.File.WriteAllLines(encryptFile, rtbList)
                rtbList.Clear()
                Return True
            End If
        Catch ex As Exception
            MessageBox.Show("Fehler:" & vbNewLine & ex.ToString(), "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return False
        End Try

        Return False
    End Function

    Function convert2List() As Boolean 'Verschlüsselt den angegebenen Text und konvertiert diesen im nächsten Schritt zu einer List(Of String)
        Try
            For Each line In rtbMain.Lines
                line = EasyCrypt.EasyCrypt.Cryptography.AES.encrypt_String(line, txtPword.Text)
                rtbList.Add(line)
            Next
            txtPword.Text = ""
            Return True
        Catch ex As Exception
            MessageBox.Show("Fehler:" & vbNewLine & ex.ToString(), "Fehler")
            Return False
        End Try
        Return False
    End Function
#End Region
#End Region
End Class